//TextSchatten_125d.js / CS2
// 30.07.07 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Dieses Script erzeugt einen Schlagschatten hinter einem Text

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Ein Dokument ffnen.");
	exit();
}

// die aktive Arbeitsflche notieren
var actSpread = app.activeWindow.activeSpread;

// die Auswahl testen
selItems = app.selection;
nItems = selItems.length;
if (nItems == 0) {
	alert ("Es ist nichts ausgewhlt.");
	exit();
}

// das erste Objekt der Auswahl prfen, bevor der Dialog gezeigt wird
if (app.selection[0].constructor.name == "Rectangle") {
	alert ("Einen Textrahmen auswhlen\nund das Script nochmals starten.");
	exit();
}

// den Handler aufrufen, welcher die gespeicherten Vorgaben einliest
var difPrefs = getPrefs();
var bName = difPrefs[0];
var offVal = difPrefs[1];
var tintVal = difPrefs[2];
// die Namen der beiden Grundfarben bersetzen
if (bName == "Black") {
	bName = "Schwarz";
}
else if (bName == "Paper") {
	bName = "Papier";
}
// den Handler aufrufen, welcher die Liste der Farben vorbereitet
var colorList = getColorList(bName);
// den Handler aufrufen, welcher den Dialog zeigt
var shadowDef = askUser();
// den Handler aufrufen, welcher das Ergebnis in eine Datei schreibt
	writeResult(shadowDef);
// die Elemente der Definition ausziehen
var tmpDef = shadowDef.split("\n");
var aColor = tmpDef[0];
var aOffset = tmpDef[1] * 1;
var aTint = tmpDef[2] * 1;
// eine Schleife durch die ausgewhlten Rahmen
for (var i=0; i<nItems; i++) {
	var curType = selItems[i].constructor.name;
	checkFrame(i, curType, aColor, aOffset, aTint);
}
// die Auswahl aufheben
app.selection = null;

// der Handler, welcher die Rahmen prft
function checkFrame(i, curType, aColor, aOffset, aTint) {
	if (curType != "Group") {
		// den Handler aufrufen, welcher den aktuellen Rahmen prft
		frameInfo = getFrame(i, curType);
		var textFrame = frameInfo[0];
		var id1 = frameInfo[1];
		var selType = frameInfo[2];
		var aFlag = frameInfo[3];
		// den Handler aufrufen, welcher den Rahmen dupliziert
		dupBox(curType, textFrame, id1, aColor, aOffset, aTint, selType, aFlag);
	}
	else {
		curGroup = selItems[i].allPageItems;
		newFrames = selItems[i].ungroup();
		for (k=0; k<curGroup.length; k++) {
			var curType = curGroup[k].constructor.name;
			// den Handler aufrufen, welcher den aktuellen Rahmen prft
			frameInfo = getGroup(k, curGroup, curType);
			var textFrame = frameInfo[0];
			var id1 = frameInfo[1];
			var selType = frameInfo[2];
			var aFlag = frameInfo[3];
			// den Handler aufrufen, welcher den Rahmen dupliziert
			dupBox(curType, textFrame, id1, aColor, aOffset, aTint, selType, aFlag);
		}
		
	}
}

// der Handler, welcher die Informationen vorbereitet
function getPrefs() {
	var shadowDef = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	var f = new File("~/Library/Preferences/schatten.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			shadowDef = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	
	// die drei Werte des Schattens ausziehen
	if (shadowDef != "") {
		var defVal = shadowDef.split("\n");
		var bName = defVal[0];
		var offVal = defVal[1] * 1;
		var tintVal = defVal[2] * 1;
	}
	else {
		var bName = "Black";
		var offVal = 0.3;
		var tintVal = 100;
	}
	return [bName, offVal, tintVal];
}

// der Handler, welcher die Liste der Farben vorbereitet
function getColorList(bName) {
	// eine Variable als Referenz zu den Farbfeldern des aktiven Dokuments definieren
	var allSwatches = app.documents[0].swatches;
	
	// prfen, ob die Vorgabefarbe existiert
	if (bName != "Schwarz" && bName != "Papier") {
		var okay = false;
		try {
			okay = app.documents[0].colors.item(bName).colorValue;
		}
		catch (e) {
		}
		if (okay == false) {
			bName = "Schwarz";
		}
	}
	
	// die Liste der Farben zusammenstellen
	// "Schwarz" an die zweite Stelle setzen (wenn es nicht das erste Element ist),
	// "Paper" in "Papier" umbenennen, die Elemente "None", "Black", "Registration" 
	// oder die Vorgabefarbe (= bName) auslassen
	var colorList = new Array();
	colorList[0] = bName;
	if (bName != "Schwarz") {
		colorList.push("Schwarz");
	}
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "Paper") {
			cName = "Papier";
		}
		if (cName != bName && cName != "None" && cName != "Black" && cName != "Registration") {
			colorList.push(cName);
		}
	}
	return colorList;
}

function askUser() {
	// Dialoge, welche eventuell im Speicher geblieben sind, lschen
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	
	// einen Dialog vorbereiten
	var aDialog = app.dialogs.add({name:"Textschatten", canCancel:true});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					var colorNames = dropdowns.add({stringList:colorList, selectedIndex:0, minWidth:130});
				}
			}
			with (dialogRows.add()) {
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Versatz:"});
					}
					with (dialogColumns.add()) {
						var shadowOffset = realEditboxes.add({editValue:offVal, minWidth:32});
					}
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"mm", minWidth:26});
					}
				}
				with (borderPanels.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Tonwert:"});
					}
					with (dialogColumns.add()) {
						var shadowTint = realEditboxes.add({editValue:tintVal, minimumValue:0, maximumValue:100, minWidth:32});
					}
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"%", minWidth:12});
					}
				}
				with (dialogColumns.add()) {
					staticTexts.add({staticLabel:"", minWidth:4});
				}
			}
		}
	}
	
	// den Dialog anzeigen
	if (aDialog.show() == true) {
		var aColor, aOffset, aTint;
		// die Wahl des Anwenders bernehmen
		// der Name der Farbe ist das Element 'selectedIndex' des Arrays 'colorList'
		aColor = colorList[colorNames.selectedIndex];
		if (aColor == "Schwarz") {
			aColor = "Black";
		}
		else if (aColor == "Papier") {
			aColor = "Paper";
		}
		// der Versatz des Schattens
		aOffset = shadowOffset.editValue;
		// der Tonwert des Schattens
		aTint = shadowTint.editValue;
		
		// den Dialog aus dem Speicher entfernen
		aDialog.destroy();
		
		var shadowDef = aColor + "\n" + aOffset + "\n" + aTint;
	}
	else {
		aDialog.destroy();
		exit();
	}
	return shadowDef;
}

// das Ergebnis in eine Datei schreiben
// die Zeile mit 'encoding' dient zum Konvertieren von Akzentbuchstaben
// et autres apostrophes
function writeResult(shadowDef) {
	var f = new File("~/Library/Preferences/schatten.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		f.encoding = "ISO-8851-9" 
		f.write(shadowDef);
		f.close();
	}
}

// der Handler welcher den Rahmen prft
function getFrame(i, curType) {
	// die Art des Rahmens feststellen
	var selType = 0;
	if (curType == "TextFrame") {
		selType = 1;
		var textFrame = selItems[i];
	}
	else if (curType == "InsertionPoint" || curType == "Character" || curType == "Text" || curType == "Word" 
		|| curType == "Line" || curType == "Paragraph" || curType == "TextStyleRange" || curType == "TextColumn") {
		app.selection = selItems[i].parentTextFrames[0];
		var textFrame = selItems[i].parentTextFrames[0];
		selType = 1;
	}
	else if (curType == "Polygon" || curType == "GraphicLine") {
		var textFrame = selItems[i];
		selType = 2;
	}
	
	// prfen, ob der Rahmen Text enthlt
	var numChars = 0;
	var aFlag = 0;
	if (selType == 1) {
		try {
			numChars = textFrame.texts.item(0).length;
			aFlag = 1;
		}
		catch (e) {
		}
		if (numChars == 0) {
			try {
				var aTextPath = textFrame.textPaths.length;
				if (aTextPath == 1) {
					numChars = textFrame.textPaths.item(0).texts.item(0).length;
					aFlag = 2;
				}
			}
			catch (e) {
			}
		}
	}
	else if (selType == 2) {
		try {
			numChars = textFrame.textPaths.item(0).texts.item(0).length;
			aFlag = 2;
		}
		catch (e) {
		}
	}
	else if (selType == 0) {
		alert ("Einen Textrahmen auswhlen.");
		exit();
	}
	
	if (numChars == 0) {
		alert ("Der ausgewhlte Rahmen enthlt keinen Text.");
		exit();
	}
	// die 'id'-Nummer des ausgewhlten Rahmens speichern
	id1 = textFrame.id;
	return [textFrame, id1, selType, aFlag];
}

function getGroup(k, curGroup, curType) {
	var selType = 0;
	if (curType == "TextFrame") {
		selType = 1;
		var textFrame = curGroup[k];
	}
	else if (curType == "InsertionPoint" || curType == "Character" || curType == "Text" || curType == "Word" 
		|| curType == "Line" || curType == "Paragraph" || curType == "TextStyleRange" || curType == "TextColumn") {
		app.selection = curGroup[k].parentTextFrames[0];
		var textFrame = curGroup[k];
		selType = 1;
	}
	else if (curType == "Polygon" || curType == "GraphicLine") {
		var textFrame = curGroup[k];
		selType = 2;
	}
	
	// prfen, of der Rahmen Text enthlt
	var numChars = 0;
	var aFlag = 0;
	if (selType == 1) {
		try {
			numChars = textFrame.texts.item(0).length;
			aFlag = 1;
		}
		catch (e) {
		}
		if (numChars == 0) {
			try {
				var aTextPath = textFrame.textPaths.length;
				if (aTextPath == 1) {
					numChars = textFrame.textPaths.item(0).texts.item(0).length;
					aFlag = 2;
				}
			}
			catch (e) {
			}
		}
	}
	else if (selType == 2) {
		try {
			numChars = textFrame.textPaths.item(0).texts.item(0).length;
			aFlag = 2;
		}
		catch (e) {
		}
	}
	else if (selType == 0) {
		alert ("Einen Textrahmen auswhlen.");
		exit();
	}
	
	if (numChars == 0) {
		alert ("Der ausgewhlte Rahmen enthlt keinen Text.");
		exit();
	}
	// die 'id'-Nummer des ausgewhlten Rahmens speichern
	id1 = textFrame.id;
	return [textFrame, id1, selType, aFlag];
}

// den Textrahmen duplizieren
function dupBox(curType, textFrame, id1, aColor, aOffset, aTint, selType, aFlag) {
	var shadowBox = textFrame.duplicate();
	// die Rahmen der aktiven Arbeitsflche zhlen
	var pItems = actSpread.pageItems.length;
	
	if (pItems > 2) {
		// die 'id'-Nummern-Liste der Objekte aufstellen
		var idList = actSpread.pageItems.everyItem().id;
		// die Z-Position des ausgewhlten Rahmens ausfindig machen
		for (var i=0; i<pItems; i++) {
			if (idList[i] == id1) {
				var itPos = i;
				break;
			}
		}
	}
	
	// die Kopie hinter den Original-Rahmen bewegen
	if (pItems == 2) {
		shadowBox.sendToBack();
	}
	else if (pItems == 3) {
		if (itPos == 1) {
			textFrame.bringToFront();
		}
		else {
			shadowBox.sendToBack();
		}
	}
	else {
		if (itPos == 1) {
			textFrame.bringToFront();
		}
		else {
			var txtFrameParent = textFrame.parent;
			if (txtFrameParent != "[object Group]") {
				try {
					var tmpGroup = actSpread.groups.add(actSpread.pageItems.itemByRange(1, itPos));
					tmpGroup.bringToFront();
					tmpGroup.ungroup();
				}
				catch (e) {
				}
			}
			else {
				shadowBox.sendToBack();
			}
		}
	}
	// den Handler "getBounds" aufrufen, um die Position des Schattenrahmens auszurechnen
	shadowBox.geometricBounds = getBounds(shadowBox, aOffset);
	// die ausgewhlte Farbe und den Tonwert zuweisen
	if (aFlag == 1) {
		shadowBox.texts.item(0).fillColor = aColor;
		shadowBox.texts.item(0).fillTint = aTint;
	}
	else if (aFlag == 2) {
		shadowBox.textPaths.item(0).texts.item(0).fillColor = aColor;
		shadowBox.textPaths.item(0).texts.item(0).fillTint = aTint;
	}
}

// nichtdruckende Zeichen am Ende des Schattentextes entfernen (Return, Neue Zeile, 
// Nchste Spalte, Nchster Rahmen, Nchste Seite, Nchste ungerade Seite, Nchste gerade Seite)
try {
	var cleanUp = true;
	while (cleanUp == true) {
		lastChar = shadowBox.parentStory.paragraphs[-1].characters[-1].contents;
		if (lastChar == "\r" || lastChar == "\n" || lastChar == 1396927554 || lastChar == 1397125698 
		|| lastChar == 1397778242 || lastChar == 1397715010 || lastChar == 1397059650) {
			shadowBox.parentStory.paragraphs[-1].characters[-1].remove();
		}
		else {
			cleanUp = false;
		}
	}
}
catch (e) {
}

// der Handler, welcher die Position des Schattenrahmens ausrechnet
function getBounds(shadowBox, aOffset) {
	var y1, x1, y2, x2;
	y1 = shadowBox.geometricBounds[0] + aOffset;
	x1 = shadowBox.geometricBounds[1] + aOffset;
	y2 = shadowBox.geometricBounds[2] + aOffset;
	x2 = shadowBox.geometricBounds[3] + aOffset;
	return [y1, x1, y2, x2];
}